#!/bin/sh
#
# Copyright (c) 2026 The NetBSD Foundation, Inc.
# All rights reserved.
#
# This code is derived from software contributed to The NetBSD Foundation
# by Christos Zoulas.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Get the ramdisk size from a file

PROG=$(basename "$0")

kernel=INSTALL
src=/usr/src
arch=$(uname -m)

usage() {
	printf >&2 'Usage: %s [-a <arch>] [-k <kernel>] [-s <srcdir>]\n' \
	    "${PROG}"
	exit 1
}

getsize() {
	set -f

	MDRSZ=$(grep MEMORY_DISK_ROOT_SIZE "$1") || return 1
	set -- ${MDRSZ}

	case "$2" in
	MEMORY_DISK_ROOT_SIZE=*[!0-9]*)
		return 1;;
	MEMORY_DISK_ROOT_SIZE=*)
		eval "$2";;
	*)
		return 1;;
	esac

	# should the following round down (as it does now), or up?
	printf '%dk\n' "$(( MEMORY_DISK_ROOT_SIZE / 2 ))"

	# leave exit status from printf, so we fail if output fails.
}

while getopts a:k:s: i
do
	case $i in
	a)	arch=$OPTARG;;
	k)	kernel=$OPTARG;;
	s)	src=$OPTARG;;
	*)
		usage;;
	esac
done
shift $((OPTIND - 1))

file=$src/sys/arch/$arch/conf/$kernel

if ! [ -f "$file" ]; then
	printf >&2 "%s: Can't open '%s'\\n" "${PROG}" "${file}"
	exit 1
fi

getsize "$file" || {
	printf >&2 '%s: Bad/missing MEMORY_DISK_ROOT_SIZE in %s\n' \
	    "${PROG}" "${file}"
	exit 1
}
